@use "sass:map";
@use "../../core/" as adm;

$name: 'adm-radio';
$component-tokens: (
	#{$name}: (
		default: (
			// backgrounds 
            background: transparent,
            background-hover: adm.c-token($name, 'background'),
            background-focus: adm.c-token($name, 'background'),
            
            background-checked: purple,
            background-checked-hover: adm.c-token($name, 'background-checked'),
            background-checked-focus: adm.c-token($name, 'background-checked'),

            // borders
            border: 1px solid grey,
			border-hover: adm.c-token($name, 'border'),
			border-focus: adm.c-token($name, 'border'),

			border-checked: 1px solid purple,
            border-checked-hover: adm.c-token($name, 'border-checked'),
            border-checked-focus: adm.c-token($name, 'border-checked'),

            // outline for focus
			outline-offset: 2px,            
            outline: 2px solid #000,
            outline-checked: adm.c-token($name, 'outline'),
						
            // misc
            radius: 100%,
            gap: 0.5rem,
            transition: 'all 0.2s ease-in-out',

            // size
            width: 1.2rem,
            height: 1.2rem,

            // icon
            icon: adm.svg-icon('<svg width="32" height="32" viewBox="0 0 32 32" xmlns="http://www.w3.org/2000/svg" fill="var(--adm-icon-color)"><rect x="8" y="8" width="16" height="16" rx="8" /></svg>', '#ffffff'),
            icon-transition: 'all 0.2s ease-in-out',
            icon-transform: none,
            icon-checked-transform: none,
            icon-opacity: 0,
            icon-size: 100%,
            icon-checked-opacity: 1,  
            
            // label
            label-font-family: inherit,
            label-font-size: 1rem,
            label-font-weight: 400,
            label-line-height: 1.5rem,
		),
	),
) !default;

@mixin generate-component-markup() {
    :host {
        box-sizing: border-box;
    }
    .#{$name} {
        
        display: flex;
        align-items: center;
        gap: adm.c-token($name, 'gap');
        

        .radio {
            appearance: none;
            position: relative;
            margin: 0;
            padding: 0;

            width: adm.c-token($name, 'width');
            height: adm.c-token($name, 'height');

            background: adm.c-token($name, 'background');
            border: adm.c-token($name, 'border');
            border-radius: adm.c-token($name, 'radius');
            position: relative;
            outline-offset: adm.c-token($name, 'outline-offset');

            // icon
            &::before {
                content: '';
                display: block;
                position: absolute;
                top: 0;
                left: 0;
                width: 100%;
                height: 100%;
                background-image: adm.c-token($name, 'icon');
                background-repeat: no-repeat;
                background-position: center;
                background-size: adm.c-token($name, 'icon-size');
                transition: adm.c-token($name, 'icon-transition');
                opacity: adm.c-token($name, 'icon-opacity');
                transform: adm.c-token($name, 'icon-transform');
            }

            &:hover {
                background: adm.c-token($name, 'background-hover');
                border: adm.c-token($name, 'border-hover');
            }

            &:focus-visible {
                background: adm.c-token($name, 'background-focus');
                border: adm.c-token($name, 'border-focus');
                outline: adm.c-token($name, 'outline');
            }


            &:checked {
                background: adm.c-token($name, 'background-checked');
                border: adm.c-token($name, 'border-checked');


                &::before {
                    opacity: adm.c-token($name, 'icon-checked-opacity');
                    transform: adm.c-token($name, 'icon-checked-transform');
                }

                &:hover {
                    background-color: adm.c-token($name, 'background-checked-hover');
                    border: adm.c-token($name, 'border-checked-hover');
                }
        
                &:focus-visible {
                    background: adm.c-token($name, 'background-checked-focus');
                    border: adm.c-token($name, 'border-checked-focus');
                    outline: adm.c-token($name, 'outline-checked');
                }
            }
        }

        

        .label {
            font-family: adm.c-token($name, 'label-font-family');
            font-size: adm.c-token($name, 'label-font-size');
            font-weight: adm.c-token($name, 'label-font-weight');
            line-height: adm.c-token($name, 'label-line-height');
        }   
    }

    :host([disabled]),
    [disabled] {
        opacity: 0.4;
        pointer-events: none;
    }

    // individual code
	@content;
}